Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jbpm.jpdl.el.impl
Class ExpressionEvaluatorImpl

    java.lang.Object
      org.jbpm.jpdl.el.ExpressionEvaluator
          org.jbpm.jpdl.el.impl.ExpressionEvaluatorImpl

    public class ExpressionEvaluatorImpl

extends ExpressionEvaluator

This is the main class for evaluating expression Strings. An expression String is a String that may contain expressions of the form ${...}. Multiple expressions may appear in the same expression String. In such a case, the expression String's value is computed by concatenating the String values of those evaluated expressions and any intervening non-expression text, then converting the resulting String to the expected type using the PropertyEditor mechanism.

In the special case where the expression String is a single expression, the value of the expression String is determined by evaluating the expression, without any intervening conversion to a String.

The evaluator maintains a cache mapping expression Strings to their parsed results. For expression Strings containing no expression elements, it maintains a cache mapping ExpectedType/ExpressionString to parsed value, so that static expression Strings won't have to go through a conversion step every time they are used. All instances of the evaluator share the same cache. The cache may be bypassed by setting a flag on the evaluator's constructor.

The evaluator must be passed a VariableResolver in its constructor. The VariableResolver is used to resolve variable names encountered in expressions, and can also be used to implement "implicit objects" that are always present in the namespace. Different applications will have different policies for variable lookups and implicit objects - these differences can be encapsulated in the VariableResolver passed to the evaluator's constructor.

Most VariableResolvers will need to perform their resolution against some context. For example, a JSP environment needs a PageContext to resolve variables. The evaluate() method takes a generic Object context which is eventually passed to the VariableResolver - the VariableResolver is responsible for casting the context to the proper type.

Once an evaluator instance has been constructed, it may be used multiple times, and may be used by multiple simultaneous Threads. In other words, an evaluator instance is well-suited for use as a singleton.

Version:
  $Change: 181177 $$DateTime: 2001/06/26 08:45:09 $$Author$
Author:
  Nathan Abramson - Art Technology Group, Shawn Bayern

Constructor Summary
`ExpressionEvaluatorImpl()` Constructor
`ExpressionEvaluatorImpl(boolean pBypassCache)` Constructor

Method Summary
`java.lang.Object` | `evaluate(java.lang.String pExpressionString, java.lang.Class pExpectedType, VariableResolver pResolver, FunctionMapper functions)` Evaluates the given expression String
`java.lang.String` | `parseAndRender(java.lang.String pExpressionString)` Parses the given expression string, then converts it back to a String in its canonical form.
`Expression` | `parseExpression(java.lang.String expression, java.lang.Class expectedType, FunctionMapper fMapper)` Prepare an expression for later evaluation.
`java.lang.Object` | `parseExpressionString(java.lang.String pExpressionString)` Gets the parsed form of the given expression string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ExpressionEvaluatorImpl

    public ExpressionEvaluatorImpl()

  Constructor

### ExpressionEvaluatorImpl

    public ExpressionEvaluatorImpl(boolean pBypassCache)

  Constructor

  Parameters:
    `pBypassCache` - flag indicating if the cache should be bypassed

Method Detail

### evaluate

    public java.lang.Object evaluate(java.lang.String pExpressionString,
                                     java.lang.Class pExpectedType,
                                     VariableResolver pResolver,
                                     FunctionMapper functions)
                              throws ELException

  Evaluates the given expression String

  Specified by:
    `evaluate` in class `ExpressionEvaluator`
  Parameters:
    `pExpressionString` - The expression to be evaluated.
    `pExpectedType` - The expected type of the result of the evaluation
    `pResolver` - A VariableResolver instance that can be used at runtime to resolve the name of implicit objects into Objects.
    `functions` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation.
  Returns:
    the expression String evaluated to the given expected type
  Throws:
    `ELException` - Thrown if the expression evaluation failed.

### parseExpression

    public Expression parseExpression(java.lang.String expression,
                                      java.lang.Class expectedType,
                                      FunctionMapper fMapper)
                               throws ELException

  Prepare an expression for later evaluation. This method should perform syntactic validation of the expression; if in doing so it detects errors, it should raise an ELParseException.

  Specified by:
    `parseExpression` in class `ExpressionEvaluator`
  Parameters:
    `expression` - The expression to be evaluated.
    `expectedType` - The expected type of the result of the evaluation
    `fMapper` - A FunctionMapper to resolve functions found in the expression. It can be null, in which case no functions are supported for this invocation. The ExpressionEvaluator must not hold on to the FunctionMapper reference after returning from `parseExpression()`. The `Expression` object returned must invoke the same functions regardless of whether the mappings in the provided `FunctionMapper` instance change between calling `ExpressionEvaluator.parseExpression()` and `Expression.evaluate()`.
  Returns:
    The Expression object encapsulating the arguments.
  Throws:
    `ELException` - Thrown if parsing errors were found.

### parseExpressionString

    public java.lang.Object parseExpressionString(java.lang.String pExpressionString)
                                           throws ELException

  Gets the parsed form of the given expression string. If the parsed form is cached (and caching is not bypassed), return the cached form, otherwise parse and cache the value. Returns either a String, Expression, or ExpressionString.

  Throws:
    `ELException`

### parseAndRender

    public java.lang.String parseAndRender(java.lang.String pExpressionString)
                                    throws ELException

  Parses the given expression string, then converts it back to a String in its canonical form. This is used to test parsing.

  Throws:
    `ELException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD